; Azimut Project
; Copyright  2008 Philippe Coulombe. All rights reserved.

.486
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

UNICODE = 1

INCLUDE \AZIMUT\INCLUDE\AZIMUT.INC

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

INCLUDE \AZIMUT\INC32\AZMT32.INC
INCLUDE \AZIMUT\INC32\comctl32.inc
INCLUDE \AZIMUT\INC32\comdlg32.inc
INCLUDE \AZIMUT\INC32\kernel32.inc
INCLUDE \AZIMUT\INC32\ole32.inc
INCLUDE \AZIMUT\INC32\shlwapi.inc
INCLUDE \AZIMUT\INC32\shell32.inc
INCLUDE \AZIMUT\INC32\user32.inc

INCLUDELIB \AZIMUT\LIB32\AZMT32.LIB
INCLUDELIB \AZIMUT\LIB32\comctl32.lib
INCLUDELIB \AZIMUT\LIB32\comdlg32.lib
INCLUDELIB \AZIMUT\LIB32\kernel32.lib
INCLUDELIB \AZIMUT\LIB32\ole32.lib
INCLUDELIB \AZIMUT\LIB32\shlwapi.lib
INCLUDELIB \AZIMUT\LIB32\shell32.lib
INCLUDELIB \AZIMUT\LIB32\user32.lib

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DialogProc      PROTO :DWORD,:DWORD,:DWORD,:DWORD   ; Dialog procedure (WM_INITDIALOG / WM_COMMAND / etcetera...)
BrowseForInput  PROTO :DWORD                        ; Browse for the binary input path or from command-line
BrowseForOutput PROTO                               ; Browse for the folder output path
WtFormEnabled   PROTO :DWORD                        ; Adjust the dialog when the worker thread is active/inactive
WtBuildFiles    PROTO :DWORD                        ; The Worker thread build the object and include files

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DLG1_ID         EQU 1               ; Dialog
ICO1_ID         EQU 1               ; Program icon
STC2_ID         EQU 202             ; Binary input path
STC4_ID         EQU 204             ; Folder output path
STC8_ID         EQU 208             ; Messages
CHK1_ID         EQU 301             ; MS COFF (leading underscore)
EDT1_ID         EQU 401             ; Label name
EDT1_MAX_LEN    EQU 22              ; Max length for the label name (4*x - 2)
CBO1_ID         EQU 501             ; Alignment
BTN1_ID         EQU 601             ; Browse for binary input path
BTN2_ID         EQU 602             ; Browse for folder output path
BTN3_ID         EQU 603             ; Build the object and include file

WM_APP_WT_INIT  EQU (WM_APP + 1)    ; Worker thread initializing (get the data from dialog controls)
WM_APP_WT_END   EQU (WM_APP + 2)    ; Worker thread ending (display success/error message)

WT_PARAMS STRUCT
  lpBinPath     DWORD ?             ; Pointer to the local buffer of the input path (binary)
  lpOutPath     DWORD ?             ; Pointer to the local buffer of the output path (folder)
  lpLabelName   DWORD ?             ; Pointer to the local buffer of the label name
  lpIncBuffer   DWORD ?             ; Pointer to the local buffer of the include file
  dwAlignIndex  DWORD ?             ; 0=Align 1 / 1=Align 2 / 2=Align 4 / etcetera...
  dwMsCoffChk   DWORD ?             ; Add or remove the leading underscore from the label name
WT_PARAMS ENDS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA

ALIGN 4
AzmtStr szProgName, TCHAR, <BIN2OBJ/0>
ALIGN 4
AzmtStr szProgNameError, TCHAR, <BIN2OBJ - Error/0>
ALIGN 4
AzmtStr szMsgWaiting, TCHAR, <Waiting for a binary file selection./0>
ALIGN 4
AzmtStr szMsgReady, TCHAR, <Ready to build the object file./0>
ALIGN 4
AzmtStr szMsgProgress, TCHAR, <Object file creation in progress. Please wait.../0>
ALIGN 4
AzmtStr szErrSuccess, TCHAR, <Object file created successfully/0>
ALIGN 4
AzmtStr szErrThread, TCHAR, <The worker has failed to be executed./0>
ALIGN 4
AzmtStr szErrPathLimit, TCHAR, <The path of the object file exceed the MAX_PATH limit./0>
ALIGN 4
AzmtStr szErrAlignIndex, TCHAR, <Failed to get the alignment option./0>
ALIGN 4
AzmtStr szErrBinOpen, TCHAR, <Failed to open the binary file./0>
ALIGN 4
AzmtStr szErrBinSize, TCHAR, <Failed to get the size of the binary file./0>
ALIGN 4
AzmtStr szErrBinRead, TCHAR, <Failed to read the binary file./0>
ALIGN 4
AzmtStr szErrBinMemory, TCHAR, <Failed to allocate memory for the binary file./0>
ALIGN 4
AzmtStr szErrObjCreate, TCHAR, <Failed to create the object file./0>
ALIGN 4
AzmtStr szErrObjSize, TCHAR, <Failed to get the size of the object file./0>
ALIGN 4
AzmtStr szErrObjWrite, TCHAR, <Failed to write the object file./0>
ALIGN 4
AzmtStr szErrIncCreate, TCHAR, <Failed to create the include file./0>
ALIGN 4
AzmtStr szErrIncContent, TCHAR, <Failed to create the content of the include file./0>
ALIGN 4
AzmtStr szErrIncWrite, TCHAR, <Failed to write the include file./0>
ALIGN 4
AzmtStr szCaptionFile, TCHAR, <Binary input/0>
ALIGN 4
AzmtStr szCaptionFldr, TCHAR, <Folder output/0>
ALIGN 4
AzmtStr szObjExtension, TCHAR, <.obj/0>
ALIGN 4
AzmtStr szIncExtension, TCHAR, <.inc/0>
ALIGN 4
AzmtStr szAlign1, TCHAR, <1/0>
ALIGN 4
AzmtStr szAlign2, TCHAR, <2/0>
ALIGN 4
AzmtStr szAlign4, TCHAR, <4/0>
ALIGN 4
AzmtStr szAlign8, TCHAR, <8/0>
ALIGN 4
AzmtStr szAlign16, TCHAR, <16/0>
ALIGN 4
AzmtStr szAlign32, TCHAR, <32/0>
ALIGN 4
AzmtStr szAlign64, TCHAR, <64/0>
ALIGN 4
AzmtStr szAlign128, TCHAR, <128/0>
ALIGN 4
AzmtStr szAlign256, TCHAR, <256/0>
ALIGN 4
AzmtStr szAlign512, TCHAR, <512/0>
ALIGN 4
AzmtStr szAlign1024, TCHAR, <1024/0>
ALIGN 4
AzmtStr szAlign2048, TCHAR, <2048/0>
ALIGN 4
AzmtStr szAlign4096, TCHAR, <4096/0>
ALIGN 4
AzmtStr szAlign8192, TCHAR, <8192/0>
ALIGN 4
AzmtStr szDataSection, BYTE, <.data/0>
ALIGN 4
AzmtStr szDefDataName, BYTE, <MyBinData/0>
ALIGN 4
AzmtStr szIncFormat, BYTE, <EXTERNDEF /phs:BYTE/n/phs_SIZE EQU /plu/n/0>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA?

ALIGN 4

hInstance       DWORD ?     ; This module handle
hWndDlg         DWORD ?     ; Dialog handle
hStcFile        DWORD ?     ; Static 2 handle / Binary input path
hStcFldr        DWORD ?     ; Static 4 handle / Folder output path
hStcMsg         DWORD ?     ; Static 8 handle / Messages
hChkMscoff      DWORD ?     ; CheckBox 1 handle / MS COFF (leading underscore)
hEdtLabel       DWORD ?     ; Edit 1 handle / Label name
hCboAlign       DWORD ?     ; ComboBox 1 handle / Alignment
hBtnFile        DWORD ?     ; Button 1 handle / Browse for binary input path
hBtnFldr        DWORD ?     ; Button 2 handle / Browse for folder ouput path
hBtnBuild       DWORD ?     ; Button 3 handle / Build the object and include file
hCursor         DWORD ?     ; Cursor handle of the active cursor
hCursorArrow    DWORD ?     ; Cursor handle of the arrow (worker thread inactive)
hCursorWait     DWORD ?     ; Cursor handle of the hourglass (worker thread active)
bThreadActive   DWORD ?     ; TRUE/FALSE (prevent the dialog from closing when the worker thread is active)
hThread         DWORD ?     ; Worker thread handle
dwDummy         DWORD ?     ; DWORD variable that can be used anywhere (no special meaning)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.CODE

Main:

    INVOKE GetModuleHandle, NULL
    mov hInstance, eax
    INVOKE DialogBoxParam, eax, DLG1_ID, NULL, ADDR DialogProc, NULL

    INVOKE ExitProcess, NULL

    ;
    ; Don't need to be executed - it just add a reference to comctl32.dll for visual styles (manifest.xml)
    ;
    INVOKE InitCommonControls

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

DialogProc PROC p_hWndDlg:DWORD, p_uMsg:DWORD, p_wParam:DWORD, p_lParam:DWORD

    mov eax, p_uMsg

    .IF (eax == WM_INITDIALOG)

        ;
        ; Set the large icon
        ;
        INVOKE LoadIcon, hInstance, ICO1_ID
        INVOKE SendMessage, p_hWndDlg, WM_SETICON, ICON_BIG, eax

        ;
        ; Save cursor handles and set the default cursor (hCursor = arrow)
        ;
        INVOKE LoadCursor, NULL, IDC_ARROW
        mov hCursor, eax
        mov hCursorArrow, eax

        INVOKE LoadCursor, NULL, IDC_APPSTARTING
        mov hCursorWait, eax

        ;
        ; We save these handles that will be needed later
        ;
        mov eax, p_hWndDlg
        mov hWndDlg, eax

        INVOKE GetDlgItem, p_hWndDlg, STC2_ID
        mov hStcFile, eax

        INVOKE GetDlgItem, p_hWndDlg, STC4_ID
        mov hStcFldr, eax

        INVOKE GetDlgItem, p_hWndDlg, STC8_ID
        mov hStcMsg, eax

        INVOKE GetDlgItem, p_hWndDlg, CHK1_ID
        mov hChkMscoff, eax

        INVOKE GetDlgItem, p_hWndDlg, EDT1_ID
        mov hEdtLabel, eax

        INVOKE GetDlgItem, p_hWndDlg, CBO1_ID
        mov hCboAlign, eax

        INVOKE GetDlgItem, p_hWndDlg, BTN1_ID
        mov hBtnFile, eax

        INVOKE GetDlgItem, p_hWndDlg, BTN2_ID
        mov hBtnFldr, eax

        INVOKE GetDlgItem, p_hWndDlg, BTN3_ID
        mov hBtnBuild, eax

        ;
        ; Inform user the program wait for file selection
        ;
        INVOKE SendMessage, hStcMsg, WM_SETTEXT, NULL, ADDR szMsgWaiting

        ;
        ; The default is Microsoft COFF
        ;
        INVOKE SendMessage, hChkMscoff, BM_SETCHECK, BST_CHECKED, NULL

        ;
        ; The length of the label name is limited to EDT1_MAX_LEN characters
        ;
        INVOKE SendMessage, hEdtLabel, EM_SETLIMITTEXT, EDT1_MAX_LEN, NULL

        ;
        ; Set the default label name
        ;
        INVOKE SendMessageA, hEdtLabel, WM_SETTEXT, NULL, ADDR szDefDataName

        ;
        ; The alignment options are added to the ComboBox
        ;
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign1       ; Index 0
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign2       ; Index 1
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign4       ; Index 2
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign8       ; Index 3
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign16      ; Index 4
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign32      ; Index 5
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign64      ; Index 6
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign128     ; Index 7
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign256     ; Index 8
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign512     ; Index 9
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign1024    ; Index 10
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign2048    ; Index 11
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign4096    ; Index 12
        INVOKE SendMessage, hCboAlign, CB_ADDSTRING, NULL, ADDR szAlign8192    ; Index 13
        INVOKE SendMessage, hCboAlign, CB_SETCURSEL, 2, NULL                   ; The default is Align 4

        ;
        ; Binary file path from the command-line
        ; If the file exist then fill the dialog with it
        ;
        INVOKE GetCommandLine
        INVOKE PathGetArgs, eax
        mov dwDummy, eax
        INVOKE PathUnquoteSpaces, eax
        INVOKE AzmtPathFileExists, dwDummy
        .IF (eax != FALSE)

            INVOKE BrowseForInput, dwDummy

        .ENDIF

    .ELSEIF (eax == WM_SETCURSOR)

        ;
        ; Set the hourglass cursor while the worker thread is running or the arrow otherwise
        ; hCursor get change where it needs to
        ;
        INVOKE SetCursor, hCursor

    .ELSEIF (eax == WM_APP_WT_INIT)

        ;
        ; Get the informations the worker thread needs
        ;
        push esi

        mov esi, p_lParam

        INVOKE SendMessage, hStcFile, WM_GETTEXT, MAX_PATH, [esi].WT_PARAMS.lpBinPath
        INVOKE SendMessage, hStcFldr, WM_GETTEXT, MAX_PATH, [esi].WT_PARAMS.lpOutPath

        INVOKE SendMessage, hChkMscoff, BM_GETCHECK, NULL, NULL
        mov [esi].WT_PARAMS.dwMsCoffChk, eax
        mov ecx, [esi].WT_PARAMS.lpLabelName
        .IF (eax == BST_CHECKED)

            mov BYTE PTR [ecx], '_'
            inc ecx

        .ENDIF
        INVOKE SendMessageA, hEdtLabel, WM_GETTEXT, (EDT1_MAX_LEN + 1), ecx     ; +1 = including the null-char
        .IF (eax == 0)

            INVOKE lstrcatA, [esi].WT_PARAMS.lpLabelName, ADDR szDefDataName

        .ENDIF

        INVOKE SendMessage, hCboAlign, CB_GETCURSEL, NULL, NULL
        mov [esi].WT_PARAMS.dwAlignIndex, eax

        pop esi

    .ELSEIF (eax == WM_APP_WT_END)

        ;
        ; Enable all controls - Ready to build again
        ;
        INVOKE WtFormEnabled, TRUE

        ;
        ; Display success/error MessageBox
        ; p_lParam = pointer to the message returned by the worker thread
        ;
        .IF (p_lParam == OFFSET szErrSuccess)

            mov eax, OFFSET szProgName
            mov ecx, MB_OK

        .ELSE

            mov eax, OFFSET szProgNameError
            mov ecx, (MB_OK OR MB_ICONERROR)

        .ENDIF
        INVOKE AzmtMsgBox, p_hWndDlg, p_lParam, eax, ecx

    .ELSEIF (eax == WM_COMMAND)

        .IF (p_wParam == BTN1_ID)

            ;
            ; Select the input binary file
            ; The build and browse for folder output button are enabled if a file is selected
            ;
            INVOKE BrowseForInput, NULL

        .ELSEIF (p_wParam == BTN2_ID)

            ;
            ; Select the output folder
            ;
            INVOKE BrowseForOutput

        .ELSEIF (p_wParam == BTN3_ID)

            ;
            ; Call the object file creation procedure in a new thread (suspended)
            ;
            INVOKE CreateThread, NULL, 0, ADDR WtBuildFiles, p_hWndDlg, CREATE_SUSPENDED, NULL
            .IF (eax != 0)

                mov hThread, eax    ; Do not replace hThread with dwDummy in case it is used in WtFormEnabled

                ;
                ; Disable all controls - Please wait
                ;
                INVOKE WtFormEnabled, FALSE

                ;
                ; Resume the thread
                ;
                INVOKE ResumeThread, hThread
                INVOKE CloseHandle, hThread

            .ELSE

                INVOKE AzmtMsgBox, p_hWndDlg, ADDR szErrThread, OFFSET szProgNameError, (MB_OK OR MB_ICONERROR)

            .ENDIF

        .ENDIF

    .ELSEIF (eax == WM_CLOSE)

        ;
        ; Close the dialog only if the worker thread is not running
        ;
        .IF (bThreadActive == FALSE)

            INVOKE EndDialog, p_hWndDlg, NULL

        .ENDIF

    .ELSE

        mov eax, FALSE
        ret

    .ENDIF

    mov eax, TRUE
    ret

DialogProc ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BrowseForInput PROC l_lpDefFilePath:DWORD

    LOCAL l_szInitPath[MAX_PATH + 4]:TCHAR  ; Initial folder path and file name (AzmtBrowseForFile function)
    LOCAL l_szFilePath[MAX_PATH + 4]:TCHAR  ; Binary file path selected (AzmtBrowseForFile function)
    LOCAL l_lpFilePath:DWORD                ; Pointer to the file path
    LOCAL l_bReadyFlag:DWORD                ; If TRUE the build and browse for folder output button are enabled

    ;
    ; l_lpFilePath get the pointer of the buffer used (l_lpDefFilePath or l_szFilePath)
    ;
    .IF (l_lpDefFilePath == NULL)

        lea eax, l_szFilePath
        mov l_lpFilePath, eax

    .ELSE

        ;
        ; If a default file path was specified (file must exist)
        ;
        mov eax, l_lpDefFilePath
        mov l_lpFilePath, eax

        jmp @SetForm

    .ENDIF

    ;
    ; If a path was previously selected get a pointer to the folder part and a
    ; pointer to the file name part by replacing the last backslash with a null-char
    ; These two parts are passed to the AzmtBrowseForFile function
    ;
    INVOKE SendMessage, hStcFile, WM_GETTEXT, MAX_PATH, ADDR l_szInitPath
    .IF (eax != 0)

        INVOKE StrRChr, ADDR l_szInitPath, NULL, '\'
        mov TCHAR PTR [eax], 0
        add eax, TCHAR

        lea ecx, l_szInitPath

        jmp @F

    .ENDIF

    ;
    ; No previous selection made so get the current directory
    ;
    INVOKE GetCurrentDirectory, MAX_PATH, ADDR l_szInitPath
    .IF (eax != 0)

        xor eax, eax

        lea ecx, l_szInitPath

        jmp @F

    .ENDIF

    ;
    ; GetCurrentDirectory failed so make sure these two register
    ; are zeroed otherwise AzmtBrowseForFile will crash
    ;
    xor eax, eax
    xor ecx, ecx

@@:
    INVOKE AzmtBrowseForFile, l_lpFilePath, hWndDlg, ADDR szCaptionFile, ecx, eax, NULL

@SetForm:

    INVOKE SendMessage, hStcFile, WM_SETTEXT, NULL, l_lpFilePath
    INVOKE SendMessage, hStcFile, WM_GETTEXTLENGTH, NULL, NULL
    .IF (eax != 0)

        mov l_bReadyFlag, TRUE
        ;
        ; Set the output folder path
        ; Make sure the folder path ends with a backslash
        ; because it is assumed by the WtBuildFiles procedure
        ;
        INVOKE PathRemoveFileSpec, l_lpFilePath
        INVOKE PathAddBackslash, l_lpFilePath
        INVOKE SendMessage, hStcFldr, WM_SETTEXT, NULL, l_lpFilePath
        ;
        ; Inform user the program is ready to build object file
        ;
        INVOKE SendMessage, hStcMsg, WM_SETTEXT, NULL, ADDR szMsgReady

    .ELSE

        mov l_bReadyFlag, FALSE
        ;
        ; Remove the content of the output folder static control
        ;
        INVOKE SendMessage, hStcFldr, WM_SETTEXT, NULL, NULL
        ;
        ; Inform user the program is waiting for binary selection
        ;
        INVOKE SendMessage, hStcMsg, WM_SETTEXT, NULL, ADDR szMsgWaiting

    .ENDIF

    ;
    ; If a selection is made the Browse for folder
    ; output and Build button are enabled (l_bReadyFlag = TRUE)
    ;
    INVOKE EnableWindow, hBtnFldr, l_bReadyFlag
    INVOKE EnableWindow, hBtnBuild, l_bReadyFlag

    ret

BrowseForInput ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

BrowseForOutput PROC

    LOCAL l_szInitPath[MAX_PATH + 4]:TCHAR  ; Initial folder path got from the static control
    LOCAL l_szFldrPath[MAX_PATH + 4]:TCHAR  ; Folder path selected (AzmtBrowseForFolder function)

    ;
    ; Make sure the selected folder output ends with a backslash
    ; because it is assumed by the WtBuildFiles procedure
    ;
    INVOKE SendMessage, hStcFldr, WM_GETTEXT, MAX_PATH, ADDR l_szInitPath
    INVOKE AzmtBrowseForFolder, ADDR l_szFldrPath, hWndDlg, NULL, ADDR szCaptionFldr, NULL, ADDR l_szInitPath, TRUE
    .IF (eax != NULL)

        INVOKE PathAddBackslash, eax
        INVOKE SendMessage, hStcFldr, WM_SETTEXT, NULL, ADDR l_szFldrPath

    .ENDIF

    ret

BrowseForOutput ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WtFormEnabled PROC p_bEnable:DWORD

    ;
    ; Disable/enable controls and close system menu
    ;
    INVOKE EnableWindow, hChkMscoff, p_bEnable
    INVOKE EnableWindow, hEdtLabel, p_bEnable
    INVOKE EnableWindow, hCboAlign, p_bEnable
    INVOKE EnableWindow, hBtnFile, p_bEnable
    INVOKE EnableWindow, hBtnFldr, p_bEnable
    INVOKE EnableWindow, hBtnBuild, p_bEnable

    INVOKE AzmtSysMenuClose, hWndDlg, p_bEnable

    .IF (p_bEnable == FALSE)

        ;
        ; Worker thread active
        ;
        mov bThreadActive, TRUE

        ;
        ; Hourglass cursor while working
        ;
        mov eax, hCursorWait
        mov hCursor, eax

        ;
        ; Inform user the program is working
        ;
        INVOKE SendMessage, hStcMsg, WM_SETTEXT, NULL, ADDR szMsgProgress

    .ELSE

        ;
        ; Worker thread inactive
        ;
        mov bThreadActive, FALSE

        ;
        ; Arrow cursor
        ;
        mov eax, hCursorArrow
        mov hCursor, eax

        ;
        ; Inform user the program is ready to build object file
        ;
        INVOKE SendMessage, hStcMsg, WM_SETTEXT, NULL, ADDR szMsgReady

        ;
        ; If the dialog is minimized then restores it to its original position
        ; before the worker thread returned message is displayed
        ;
        INVOKE IsIconic, hWndDlg
        .IF (eax != 0)
            INVOKE ShowWindow, hWndDlg, SW_RESTORE
        .ENDIF

    .ENDIF

    ret

WtFormEnabled ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WtBuildFiles PROC p_hWndDlg:DWORD

    LOCAL l_szBinPath[MAX_PATH + 4]:TCHAR       ; Binary file path
    LOCAL l_szOutPath[MAX_PATH * 2]:TCHAR       ; obj-inc output | *2 = Concatenation of long folder and file name
    LOCAL l_szLabelName[EDT1_MAX_LEN + 2]:BYTE  ; +2 = underscore and null-char
    LOCAL l_szIncBuffer[96]:BYTE                ; Buffer that will be written to the include file
    LOCAL l_dwLabelLength:DWORD                 ; Length of the label name including the null-char terminator
    LOCAL l_dwDataFlag:DWORD                    ; IMAGE_SECTION_HEADER.Characteristics
    LOCAL l_lpData:DWORD                        ; Pointer to memory (binary file content)
    LOCAL l_dwDataSize:DWORD                    ; Size of the binary file
    LOCAL l_dwAlign:DWORD                       ; Number of padding bytes for a 4 byte boundary alignment
    LOCAL l_dwStrTblSize:DWORD                  ; Size of the String Table DWORD + LabelName + padding bytes
    LOCAL l_hFile:DWORD                         ; Handle of the file (Object and include files - in this order)
    LOCAL l_ifh:IMAGE_FILE_HEADER               ; IMAGE_FILE_HEADER Structure
    LOCAL l_ish:IMAGE_SECTION_HEADER            ; IMAGE_SECTION_HEADER Structure
    LOCAL l_ist:IMAGE_SYMBOL                    ; IMAGE_SYMBOL structure
    LOCAL l_wtp:WT_PARAMS                       ; This structure pointer is passed to the dialog to get data

    lea eax, l_szBinPath
    mov l_wtp.lpBinPath, eax

    lea eax, l_szOutPath
    mov l_wtp.lpOutPath, eax

    lea eax, l_szLabelName
    mov l_wtp.lpLabelName, eax

    lea eax, l_szIncBuffer
    mov l_wtp.lpIncBuffer, eax

    INVOKE RtlZeroMemory, l_wtp.lpLabelName, SIZEOF l_szLabelName
    INVOKE RtlZeroMemory, l_wtp.lpIncBuffer, SIZEOF l_szIncBuffer
    INVOKE RtlZeroMemory, ADDR l_ifh, SIZEOF l_ifh
    INVOKE RtlZeroMemory, ADDR l_ish, SIZEOF l_ish
    INVOKE RtlZeroMemory, ADDR l_ist, SIZEOF l_ist

    ;
    ; Pointers are past to the dialog through the WT_PARAMS structure
    ; Get the input and output path
    ; Get label name
    ; Get alignment selection index
    ; Get the ms coff checkbox
    ;
    INVOKE SendMessage, p_hWndDlg, WM_APP_WT_INIT, NULL, ADDR l_wtp

    ;
    ; If the last binary file name character is uppercase make the obj and inc extension the same
    ; The first output is the object file followed by the include file
    ; Make sure the object file path do not exceed MAX_PATH (MAX_PATH includes the null-char)
    ;
    INVOKE lstrlen, l_wtp.lpBinPath
    mov ecx, l_wtp.lpBinPath
    lea ecx, [ecx + eax*TCHAR - TCHAR]
    movzx eax, TCHAR PTR [ecx]
    INVOKE IsCharUpper, eax
    .IF (eax != 0)

        INVOKE CharUpper, ADDR szObjExtension
        INVOKE CharUpper, ADDR szIncExtension

    .ELSE

        INVOKE CharLower, ADDR szObjExtension
        INVOKE CharLower, ADDR szIncExtension

    .ENDIF

    INVOKE StrRChr, l_wtp.lpBinPath, NULL, '\'
    add eax, TCHAR
    INVOKE lstrcat, l_wtp.lpOutPath, eax
    INVOKE PathRemoveExtension, l_wtp.lpOutPath
    INVOKE lstrcat, l_wtp.lpOutPath, ADDR szObjExtension

    INVOKE lstrlen, l_wtp.lpOutPath
    .IF (eax >= MAX_PATH)

        mov eax, OFFSET szErrPathLimit
        jmp @Exit

    .ENDIF

    ;
    ; Get the selected alignment option and build the value for the
    ; Characteristics member of the IMAGE_SECTION_HEADER structure
    ; Flags for the .data section
    ;
    mov eax, l_wtp.dwAlignIndex
    .IF (eax == 0)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_1BYTES
    .ELSEIF (eax == 1)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_2BYTES
    .ELSEIF (eax == 2)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_4BYTES
    .ELSEIF (eax == 3)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_8BYTES
    .ELSEIF (eax == 4)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_16BYTES
    .ELSEIF (eax == 5)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_32BYTES
    .ELSEIF (eax == 6)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_64BYTES
    .ELSEIF (eax == 7)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_128BYTES
    .ELSEIF (eax == 8)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_256BYTES
    .ELSEIF (eax == 9)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_512BYTES
    .ELSEIF (eax == 10)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_1024BYTES
    .ELSEIF (eax == 11)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_2048BYTES
    .ELSEIF (eax == 12)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_4096BYTES
    .ELSEIF (eax == 13)
        mov l_dwDataFlag, IMAGE_SCN_ALIGN_8192BYTES
    .ELSE

        mov eax, OFFSET szErrAlignIndex
        jmp @Exit

    .ENDIF
    or l_dwDataFlag, (IMAGE_SCN_CNT_INITIALIZED_DATA OR IMAGE_SCN_MEM_READ OR IMAGE_SCN_MEM_WRITE)

    ;
    ; Open the binary file
    ; Get file size
    ; Allocate memory for the file content
    ; Read the file into memory
    ;
    INVOKE CreateFile, l_wtp.lpBinPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, NULL, NULL
    .IF (eax == INVALID_HANDLE_VALUE)

        mov eax, OFFSET szErrBinOpen
        jmp @Exit

    .ENDIF
    mov l_hFile, eax

    INVOKE GetFileSize, l_hFile, NULL
    .IF (eax == INVALID_FILE_SIZE)

        INVOKE CloseHandle, l_hFile
        mov eax, OFFSET szErrBinSize
        jmp @Exit

    .ENDIF
    mov l_dwDataSize, eax

    INVOKE VirtualAlloc, NULL, l_dwDataSize, MEM_COMMIT, PAGE_READWRITE
    .IF (eax == 0)

        INVOKE CloseHandle, l_hFile
        mov eax, OFFSET szErrBinMemory
        jmp @Exit

    .ENDIF
    mov l_lpData, eax

    INVOKE ReadFile, l_hFile, l_lpData, l_dwDataSize, ADDR dwDummy, NULL
    .IF (eax == 0)

        INVOKE CloseHandle, l_hFile
        INVOKE VirtualFree, l_lpData, 0, MEM_RELEASE
        mov eax, OFFSET szErrBinRead
        jmp @Exit

    .ENDIF
    INVOKE CloseHandle, l_hFile

    ;
    ; Calculating the padding bytes required to make the
    ; IMAGE_SYMBOL section aligned on a 4 bytes boundary
    ;
    mov l_dwAlign, 0
    mov eax, ((SIZEOF IMAGE_FILE_HEADER) + (SIZEOF IMAGE_SECTION_HEADER))
    add eax, l_dwDataSize
    mov ecx, 4
    xor edx, edx
    div ecx
    .IF (edx != 0)
        sub ecx, edx
        mov l_dwAlign, ecx
    .ENDIF

    ;
    ; IMAGE_FILE_HEADER = 20 bytes
    ;
    mov l_ifh.Machine, IMAGE_FILE_MACHINE_I386
    mov l_ifh.NumberOfSections, 1
    mov eax, SIZEOF l_ifh
    add eax, SIZEOF l_ish
    add eax, l_dwDataSize
    add eax, l_dwAlign
    mov l_ifh.PointerToSymbolTable, eax
    mov l_ifh.NumberOfSymbols, 1

    ;
    ; IMAGE_SECTION_HEADER = 40 bytes
    ;
    INVOKE lstrcpyA, ADDR l_ish._Name, ADDR szDataSection
    mov eax, l_dwDataSize
    mov l_ish.SizeOfRawData, eax
    mov eax, SIZEOF l_ifh
    add eax, SIZEOF l_ish
    mov l_ish.PointerToRawData, eax
    mov eax, l_dwDataFlag
    mov l_ish.Characteristics, eax

    ;
    ; IMAGE_SYMBOL = 18 bytes
    ;
    lea eax, l_ist.N.ShortName
    mov DWORD PTR [eax + 4], 4
    mov l_ist.SectionNumber, 1
    mov l_ist.StorageClass, IMAGE_SYM_CLASS_EXTERNAL

    ;
    ; Create the object file (existing file is overwritten)
    ; Write to file the IMAGE_FILE_HEADER + IMAGE_SECTION_HEADER + Binary data + padding bytes + IMAGE_SYMBOL
    ; Calculating the padding bytes required to make the String Table ends at a 4 bytes boundary
    ; Write to file the String Table + padding bytes
    ;
    INVOKE CreateFile, l_wtp.lpOutPath, GENERIC_WRITE, NULL, NULL, CREATE_ALWAYS, NULL, NULL
    .IF (eax == INVALID_HANDLE_VALUE)

        INVOKE VirtualFree, l_lpData, 0, MEM_RELEASE
        mov eax, OFFSET szErrObjCreate
        jmp @Exit

    .ENDIF
    mov l_hFile, eax

    INVOKE WriteFile, l_hFile, ADDR l_ifh, SIZEOF l_ifh, ADDR dwDummy, NULL
    INVOKE WriteFile, l_hFile, ADDR l_ish, SIZEOF l_ish, ADDR dwDummy, NULL
    INVOKE WriteFile, l_hFile, l_lpData, l_dwDataSize, ADDR dwDummy, NULL
    .IF (l_dwAlign != 0)

        mov eax, l_dwAlign
        mov l_dwAlign, 0
        INVOKE WriteFile, l_hFile, ADDR l_dwAlign, eax, ADDR dwDummy, NULL

    .ENDIF
    INVOKE WriteFile, l_hFile, ADDR l_ist, SIZEOF l_ist, ADDR dwDummy, NULL
    INVOKE VirtualFree, l_lpData, 0, MEM_RELEASE

    INVOKE lstrlenA, l_wtp.lpLabelName
    add eax, 1
    mov l_dwLabelLength, eax
    INVOKE GetFileSize, l_hFile, NULL
    .IF (eax == INVALID_FILE_SIZE)

        INVOKE CloseHandle, l_hFile
        INVOKE DeleteFile, l_wtp.lpOutPath
        mov eax, OFFSET szErrObjSize
        jmp @Exit

    .ENDIF
    add eax, (SIZEOF DWORD)
    add eax, l_dwLabelLength
    mov l_dwAlign, 0
    mov ecx, 4
    xor edx, edx
    div ecx
    .IF (edx != 0)
        sub ecx, edx
        mov l_dwAlign, ecx
    .ENDIF

    mov eax, (SIZEOF DWORD)
    add eax, l_dwLabelLength
    add eax, l_dwAlign
    mov l_dwStrTblSize, eax
    INVOKE WriteFile, l_hFile, ADDR l_dwStrTblSize, (SIZEOF DWORD), ADDR dwDummy, NULL
    INVOKE WriteFile, l_hFile, l_wtp.lpLabelName, l_dwLabelLength, ADDR dwDummy, NULL
    .IF (l_dwAlign != 0)

        mov eax, l_dwAlign
        mov l_dwAlign, 0
        INVOKE WriteFile, l_hFile, ADDR l_dwAlign, eax, ADDR dwDummy, NULL

    .ENDIF
    .IF (eax == 0)

        INVOKE CloseHandle, l_hFile
        INVOKE DeleteFile, l_wtp.lpOutPath
        mov eax, OFFSET szErrObjWrite
        jmp @Exit

    .ENDIF
    INVOKE CloseHandle, l_hFile

    ;
    ; Get the include file path and create it (existing file is overwritten)
    ; Get the formatted externdef and data size constant into the buffer
    ; Write the buffer into the include file
    ;
    INVOKE PathRemoveExtension, l_wtp.lpOutPath
    INVOKE lstrcat, l_wtp.lpOutPath, ADDR szIncExtension
    INVOKE CreateFile, l_wtp.lpOutPath, GENERIC_WRITE, NULL, NULL, CREATE_ALWAYS, NULL, NULL
    .IF (eax == INVALID_HANDLE_VALUE)

        mov eax, OFFSET szErrIncCreate
        jmp @Exit

    .ENDIF
    mov l_hFile, eax

    mov eax, l_wtp.lpLabelName
    .IF (l_wtp.dwMsCoffChk == BST_CHECKED)

        inc eax

    .ENDIF
    INVOKE wsprintfA, l_wtp.lpIncBuffer, ADDR szIncFormat, eax, eax, l_dwDataSize
    INVOKE StrChrA, l_wtp.lpIncBuffer, ':'
    .IF (eax == 0)

        INVOKE CloseHandle, l_hFile
        INVOKE DeleteFile, l_wtp.lpOutPath
        mov eax, OFFSET szErrIncContent
        jmp @Exit

    .ENDIF
    INVOKE CharUpperA, eax

    INVOKE lstrlenA, l_wtp.lpIncBuffer
    INVOKE WriteFile, l_hFile, l_wtp.lpIncBuffer, eax, ADDR dwDummy, NULL
    .IF (eax == 0)

        INVOKE CloseHandle, l_hFile
        INVOKE DeleteFile, l_wtp.lpOutPath
        mov eax, OFFSET szErrIncWrite
        jmp @Exit

    .ENDIF
    INVOKE CloseHandle, l_hFile

    ;
    ; Object and include files created successfully
    ;
    mov eax, OFFSET szErrSuccess

@Exit:

    ;
    ; The return code is set in the lParam of the dialog procedure
    ;
    INVOKE PostMessage, p_hWndDlg, WM_APP_WT_END, NULL, eax

    ret

WtBuildFiles ENDP

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

END Main

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
